# Alterator helperl utilites

class TrueClass
  def quote
    '#t'
  end
end

class FalseClass
  def quote
    '#f'
  end
end

class Numeric
  def quote
    self.to_s
  end
end

class Symbol
  def quote
    self.to_s
  end
end

class String
  def quote
    '"' + self.gsub(/[\\"]/, '\\\\\&') + '"'
  end
end

class Exception
  def quote
    message.quote
  end
end

class Object
  def quote(wrap=true)
    arr = Array.new
    ret = ""
    if self.respond_to? :each_pair
      self.each_pair do |k,v|
        arr << k.quote << v.quote
      end
      ret << "(" if wrap
      ret << arr.join(" ")
      ret << ")" if wrap
      ret
    elsif self.respond_to? :each
      self.each do |v|
        arr << v.quote
      end
      ret << "(" if wrap
      ret << arr.join(" ")
      ret << ")" if wrap
      ret
    elsif self.respond_to? :to_str
      self.to_str.quote
    else
      raise "Dunno how to quote \"#{self.inspect}\" of class #{self.class}"
    end
  end
end

# vim: set ts=4 sw=2 et:
